var browserController = JSB.defineClass('browserController : UIViewController', {
  viewDidLoad: function() {
    self.homePageURL = 'https://m.inftab.com/'
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.reloadImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/reload.png`), 2)
    self.stopImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    // Application.sharedInstance().showHUD("process:0",Application.sharedInstance().focusWindow,5)
    self.dynamic = true;
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.engine = 'Bing'
    self.webApp = "Bilibili"
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.url = self.homePageURL;
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    // self.webview.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);
    // <<< DeepL view <<<
    // Application.sharedInstance().showHUD("process:1",Application.sharedInstance().focusWindow,5)

// >>> opacity button >>>
    self.webAppButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.webAppButton,"openWebApp:")
    self.webAppButton.setTitleForState('📺', 0);
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")
    self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    // >>> engine button >>>
    self.engineButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.engineButton,"changeEngine:")
    self.engineButton.setTitleForState('Bing', 0);
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    // <<< engine button <<<
    // >>> webAppEntries button >>>
    self.webAppEntriesButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.webAppEntriesButton,"changeWebApp:")
    self.webAppEntriesButton.setTitleForState('Bilibili', 0);
    self.webAppEntriesButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    // <<< webAppEntries button <<<
    // >>> home button >>>
    self.homeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.homeButton,"homeButtonTapped:")
    self.homeButton.setImageForState(self.homeImage,0)
    // <<< home button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.searchButton,"searchButtonTapped:")
    self.searchButton.setTitleForState('🔍', 0);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goForwardButton,"goForwardButtonTapped:")
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goBackButton,"goBackButtonTapped:")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<
    // >>> refresh button >>>
    self.refreshButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.refreshButton,"refreshButtonTapped:")
    // self.refreshButton.addTargetActionForControlEvents(self, "refreshButtonTapped:", 1 << 6);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // <<< refresh button <<<
    // Application.sharedInstance().showHUD("process:2",Application.sharedInstance().focusWindow,5)

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    // Application.sharedInstance().showHUD("process:3",Application.sharedInstance().focusWindow,5)
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);
    // Application.sharedInstance().showHUD("process:5",Application.sharedInstance().focusWindow,5)

    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xRight-18,y: yTop,width: 18,height: 18};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    if (self.toolbarOn) {
      self.screenButton.frame = {x: xRight - 41,y: yBottom - 25,width: 40,height: 25};
    }else{
      self.screenButton.frame = {x: xRight - 40,y: yBottom - 30,width: 33,height: 25};
    }
    self.engineButton.frame = {x: xRight - 106,y: yBottom - 25,width: 60,height: 25};


    if (viewFrame.width <= 300) {
      self.moveButton.frame = {x: xRight*0.5-75,y: yTop,width: viewFrame.width*0.35,height: 12};
      self.refreshButton.hidden = true
      self.goBackButton.hidden = true
      self.goForwardButton.hidden = true
      self.engineButton.hidden = true
      self.webAppEntriesButton.hidden = true
      self.homeButton.frame = {  x: xLeft + (viewFrame.width-200)*0.8,  y: yBottom - 25,  width: 47,  height: 25,};    
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: xLeft + (viewFrame.width-200)*0.8+106,  y: yBottom - 25,  width: 47,  height: 25,};
      }else{
        self.searchButton.frame = {  x: xRight - 75,  y: yBottom - 30,  width: 30,  height: 25,};
      }
      self.webAppButton.frame = {  x: xLeft + (viewFrame.width-200)*0.8+53,  y: yBottom - 25,  width: 47,  height: 25,};
    }else if (viewFrame.width <= 410) {
      self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: viewFrame.width*0.35,  height: 12,};
      self.refreshButton.hidden = !self.toolbarOn
      self.goBackButton.hidden = !self.toolbarOn
      self.homeButton.hidden = !self.toolbarOn
      self.goForwardButton.hidden = !self.toolbarOn
      self.engineButton.hidden = true
      self.webAppEntriesButton.hidden = true
      self.homeButton.frame = {  x: xLeft + 106,  y: yBottom - 25,  width: 47,  height: 25,};    
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: xRight-92,  y: yBottom - 25,  width: 47,  height: 25,};
      }else{
        self.searchButton.frame = {  x: xRight - 75,  y: yBottom - 30,  width: 30,  height: 25,};
      }
      self.webAppButton.frame = {  x: xRight-144,  y: yBottom - 25,  width: 47,  height: 25,};
    }else{
      self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: 150,  height: 12,};
      if (self.toolbarOn) {
        self.refreshButton.hidden = false
        self.goBackButton.hidden = false
        self.goForwardButton.hidden = false
        self.engineButton.hidden = false
        self.webAppEntriesButton.hidden = false
      }
      self.homeButton.frame = {  x: xLeft + 106,  y: yBottom - 25,  width:47,  height: 25,};   
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: xRight - 151,  y: yBottom - 25,  width: 40,  height: 25,};
      }else{
        self.searchButton.frame = {  x: xRight - 75,  y: yBottom - 30,  width: 30,  height: 25,}
      }
      self.webAppButton.frame = {  x: xRight - 261,  y: yBottom - 25,  width: 40,  height: 25,};  
      self.webAppEntriesButton.frame = {  x: xRight - 216,  y: yBottom - 25,  width: 60,  height: 25,};  
    }
    self.goBackButton.frame = {  x: xLeft+1,  y: yBottom - 25,  width: 30,  height: 25,};
    self.goForwardButton.frame = {  x: xLeft+36,  y: yBottom - 25,  width: 30,  height: 25,};
    self.refreshButton.frame = {  x: xLeft + 71,  y: yBottom - 25,  width: 30,  height: 25,};
    if (self.toolbarOn) {
      self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-36}
    }else{
      self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-6}
    }
    // Application.sharedInstance().showHUD("process:6",Application.sharedInstance().focusWindow,5)

  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
    // let requestFromHomepage = self.webview.url === "https://m.inftab.com/"
    let currentURL = webView.request.URL().absoluteString();
    if (!currentURL) {return}
    if (/^marginnote3app/.test(currentURL)) {
      Application.sharedInstance().openURL(NSURL.URLWithString(currentURL));
      webView.stopLoading();
      return
    }
    self.refreshButton.setImageForState(self.stopImage,0)
    self.changeButtonOpacity(0.5)
    if (/(notion.so)|(craft.do)/.test(currentURL)) {
      webView.url = currentURL
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.changeButtonOpacity(1.0)
      return;
    }
    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    if (/^https:\/\/d.bilibili/.test(currentURL)) {
      webView.stopLoading();
    }
    if (/^https:\/\/www.thesaurus.com/.test(currentURL)) {
      // Application.sharedInstance().showHUD("123", self.view.window, 5);
        self.updateThesaurusOffset()
      
    }
    if (!self.webAppEntrieNames[self.webApp].desktop && /^bilibili:/.test(currentURL)) {
      // Application.sharedInstance().showHUD("123", self.view.window, 5);
      // webView.stopLoading();
      // webview.scrollView.contentOffset = {x: 0, y: 100}; 
      webView.evaluateJavaScript(
      `//document.getElementsByClassName("launch-app-btn m-float-openapp")[0].style.display = "none";    
      document.getElementsByClassName("launch-app-btn m-nav-openapp")[0].style.display = "none"; 
      document.getElementsByClassName("mplayer-fullscreen-call-app")[0].style.display = "none";
      let itemToRemove = document.getElementsByClassName("mplayer-widescreen-callapp")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      itemToRemove = document.getElementsByClassName("m-video2-awaken-btn")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      itemToRemove = document.getElementsByClassName("launch-app-btn icon-spread")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      // document.getElementsByClassName("m-video-player")[0].style = "position: absolute; width: 100%; height: 100%; left: 0; top: 0;";`,
      (ret) => {
      }
    );         
    }


    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    // self.screenButton.setTitleForState('Loading', 0);
    // self.refreshButton.setTitleForState('✖️', 0);
    self.isLoading = true;
  },
  webViewDidFinishLoad: function(webView) {
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    // self.getCurrentURL(webView)
    // let currentURL = webView.request.URL().absoluteString();
    self.webview.url = webView.request.URL().absoluteString();
    // Application.sharedInstance().showHUD(self.webview.url, self.view.window, 5);
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    if (/https:\/\/space\.bilibili\.com\/v\/note-list.*/.test(self.webview.url)) {
      let frame = self.view.frame
      if (frame.width < 720) {
        frame.width = 720
        self.view.frame = frame
        self.currentFrame = frame
      }
      self.updateBilibiliNoteOffset()
      return;
    }else if (/https:\/\/www\.bilibili\.com\/.*/.test(self.webview.url)) {
    // Application.sharedInstance().showHUD(123, self.view.window, 5);

      let frame = self.view.frame
      if (frame.width < 720) {
        frame.width = 720
        self.view.frame = frame
        self.currentFrame = frame
      }
      if (Application.sharedInstance().osType == 0) {
        self.updateBilibiliOffset()
      }
      return;
    }
    if (/https:\/\/.*\.bing\.com\/search.*/.test(self.webview.url)) {
      self.engine = "Bing"
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      let searchedText  = self.webview.url.match(/(?<=search\?q=).*/)[0]
      self.searchedText = searchedText
    }else if (/https:\/\/.*\.baidu\.com\/s\?wd.*/.test(self.webview.url)) {
      self.engine = "Baidu"
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      let searchedText  = self.webview.url.match(/(?<=s\?wd=).*/)[0]
      self.searchedText = searchedText
    }else if (/https:\/\/www\.google\.com\/search.*/.test(self.webview.url)) {
      self.engine = "Google"
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      let searchedText  = self.webview.url.match(/(?<=search\?q=).*/)[0]
      self.searchedText = searchedText
    }
    if (self.webview.url === self.homePageURL) {
      return
    }
    switch (self.engine) {
      case "Deepl":
        self.updateDeeplOffset()
        return
      case "BaiduTranslate":
        self.updateBaiduOffset()
        return
      case "ResearchGate":
        self.updateRGOffset()
        return
      case "Bing":
        self.updateBingOffset()
        return
      case "Youdao":
        self.updateYoudaoOffset()
        return
      case "Thesaurus":
        self.updateThesaurusOffset()
        return
      default:
        break;
    }
    // Application.sharedInstance().showHUD("set should copy", self.view.window, 2);
    self.shouldCopy = false
    self.shouldComment = false
  },
  webViewDidFailLoadWithError: function(webView, error) {
  },

  changeScreen: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🔍 Search depth: '+self.searchDepth,object:self,selector:'changeSearchDepth:',param:sender},
      {title:'🔍 Color filter',object:self,selector:'changeColorFilter:',param:sender},
      {title:'🔙 Backlink ',object:self,selector:'toggleBacklink:',param:'right',checked:self.backLink},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeSearchDepth: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'*️⃣ Unlimited',object:self,selector:'setSearchDepth:',param:-1,checked:self.searchDepth===-1},
      {title:'2️⃣ Depth: 2',object:self,selector:'setSearchDepth:',param:2,checked:self.searchDepth=== 2},
      {title:'3️⃣ Depth: 3',object:self,selector:'setSearchDepth:',param:3,checked:self.searchDepth=== 3},
      {title:'4️⃣ Depth: 4',object:self,selector:'setSearchDepth:',param:4,checked:self.searchDepth=== 4},
      {title:'5️⃣ Depth: 5',object:self,selector:'setSearchDepth:',param:5,checked:self.searchDepth=== 5},
      {title:'6️⃣ Depth: 6',object:self,selector:'setSearchDepth:',param:6,checked:self.searchDepth=== 6},
      {title:'7️⃣ Depth: 7',object:self,selector:'setSearchDepth:',param:7,checked:self.searchDepth=== 7},
      {title:'8️⃣ Depth: 8',object:self,selector:'setSearchDepth:',param:8,checked:self.searchDepth=== 8},
      {title:'9️⃣ Depth: 9',object:self,selector:'setSearchDepth:',param:9,checked:self.searchDepth=== 9},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeColorFilter: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'light yellow',object:self,selector:'setColorFilter:',param:0,checked:self.color[0]},
      {title:'light green',object:self,selector:'setColorFilter:',param:1,checked:self.color[1]},
      {title:'light blue',object:self,selector:'setColorFilter:',param:2,checked:self.color[2]},
      {title:'pink',object:self,selector:'setColorFilter:',param:3,checked:self.color[3]},
      {title:'yellow',object:self,selector:'setColorFilter:',param:4,checked:self.color[4]},
      {title:'green',object:self,selector:'setColorFilter:',param:5,checked:self.color[5]},
      {title:'blue',object:self,selector:'setColorFilter:',param:6,checked:self.color[6]},
      {title:'red',object:self,selector:'setColorFilter:',param:7,checked:self.color[7]},
      {title:'orange',object:self,selector:'setColorFilter:',param:8,checked:self.color[8]},
      {title:'dark green',object:self,selector:'setColorFilter:',param:9,checked:self.color[9]},
      {title:'dark blue',object:self,selector:'setColorFilter:',param:10,checked:self.color[10]},
      {title:'dark red',object:self,selector:'setColorFilter:',param:11,checked:self.color[11]},
      {title:'white',object:self,selector:'setColorFilter:',param:12,checked:self.color[12]},
      {title:'light grey',object:self,selector:'setColorFilter:',param:13,checked:self.color[13]},
      {title:'grey',object:self,selector:'setColorFilter:',param:14,checked:self.color[14]},
      {title:'purple',object:self,selector:'setColorFilter:',param:15,checked:self.color[15]},
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  setSearchDepth:function (depth) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.searchDepth = depth
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
      // Application.sharedInstance().showHUD(self.appInstance.studyController(self.view.window).view.subviews, self.view.window, 5)
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===2) {
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }
    if (focusNote) {
      self.setMultiOrderNetwork(focusNote)
      // self.setNetwork(focusNote)
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({backLink:self.backLink,searchDepth:self.searchDepth,colorFilter:self.color},"MNNetwork")
    // self.setMultiOrderNetwork()
  },
  setColorFilter:function (color) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.color[color] = !self.color[color]
    NSUserDefaults.standardUserDefaults().setObjectForKey({backLink:self.backLink,searchDepth:self.searchDepth,colorFilter:self.color},"MNNetwork")
    // Application.sharedInstance().showHUD(self.color, self.view.window, 5)

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
  },
  toggleBacklink:function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.backLink = !self.backLink
    NSUserDefaults.standardUserDefaults().setObjectForKey({backLink:self.backLink,searchDepth:self.searchDepth,colorFilter:self.color},"MNNetwork")
    
    // Application.sharedInstance().showHUD(self.color, self.view.window, 5)

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
  },
  searchButtonTapped: function() {
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
      // Application.sharedInstance().showHUD(self.appInstance.studyController(self.view.window).view.subviews, self.view.window, 5)
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===2) {
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }
    if (focusNote) {
      // self.setMultiOrderNetwork(focusNote)
      self.setNetwork(focusNote)
    }else{
      self.appInstance.showHUD("No note selected", this.view.window, 2)
    }
      },
  multiButtonTapped: function() {
      // Application.sharedInstance().showHUD(123, self.view.window, 5)
    let docMapSplitMode = self.appInstance.studyController(self.view.window).docMapSplitMode
    // UIPasteboard.generalPasteboard().string = self.appInstance.studyController(self.view.window).view.subviews
    let focusNote
    if (docMapSplitMode===2) {
      focusNote = self.appInstance.studyController(self.view.window).readerController.documentControllers[0].focusNote
    }else{
      focusNote = self.appInstance.studyController(self.view.window).notebookController.focusNote
    }
    if (focusNote) {
      self.setMultiOrderNetwork(focusNote)
      // self.setNetwork(focusNote)
    }else{
      self.appInstance.showHUD("No note selected", this.view.window, 2)
    }
      },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  focusButtonTapped: function() {
    self.webview.evaluateJavaScript(`
      network.focus("${self.noteid}",{scale:1,animation:true})
    `,ret=>{})
  },
  closeButtonTapped: function() {
    self.view.hidden = true;
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if (!self.miniMode && (Date.now() - self.moveDate) > 100) {
      // self.appInstance.showHUD("state:"+gesture.state, self.view.window, 2);
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
      }
      // if ((newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20) || !self.locationToBrowser) {

      // }
    }
    self.moveDate = Date.now()
    let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}

    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (!self.miniMode) {
      if (locationToMN.x<40) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:0,
          y:locationToMN.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.focusButton.hidden = true
        self.multiButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (locationToMN.x>studyFrame.width-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.searchButton.hidden = true
        self.focusButton.hidden = true
        self.multiButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (locationToMN.x<50) {
        self.view.frame = {
          x:0,
          y:locationToMN.y-20,
          width:40,
          height:40
        }
        return
      }else if (locationToMN.x>studyFrame.width-50) {
        self.view.frame = {
          x:studyFrame.width-40,
          y:locationToMN.y-20,
          width:40,
          height:40
        }
        return
      }else if (locationToMN.x>50) {
        self.view.frame = {
          x:x,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        self.currentFrame = self.view.frame
        self.view.hidden = false
        self.webview.hidden = false
        self.focusButton.hidden = false
        self.multiButton.hidden = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.webview.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        self.miniMode = false
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
});
browserController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
browserController.prototype.setNetwork = function (focusNote) {
  this.htmlMode = true
  this.noteid = focusNote.noteId
  this.nodes = [];
  this.getLinkNodes(focusNote,1,1)
  // this.titleLink = true
  // UIPasteboard.generalPasteboard().string = linkedNotes.join(",")
  // let titleLinkNote = this.getTitleLinks(focusNote)
  // this.appInstance.showHUD("length:"+titleLinkNote.length,this.view.window,2)

  let backLinedNotes = this.getBackLinks(focusNote)
  let AllNodes =  Array.from(new Set(
                  this.nodes
                  .map(linkedNote=>Database.sharedInstance().getNoteById(linkedNote))
                  .concat(backLinedNotes,focusNote)
                  ))
  let titleColor = ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
  let noteColorHexes = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    noteColorHexes = ["#d2d294","#a8d1a1","#94accf","#d89dac","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#aa8ec4"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexes = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }
  // this.appInstance.showHUD("length:"+AllNodes.length,this.view.window,2)
    let allNodesHtml = AllNodes.map((nodeNote)=>{
    // let nodeNote = Database.sharedInstance().getNoteById(node.noteid)
    let backgroundColor = noteColorHexes[nodeNote.colorIndex]
    let fontColor = titleColor[nodeNote.colorIndex]
    return this.getNodeInfo(nodeNote,backgroundColor,fontColor);
  }).join(",")
    // UIPasteboard.generalPasteboard().string = allNodesHtml

  let backEdgesHtml = backLinedNotes.map((node)=>`{ from: "${node.noteId}", to: "${focusNote.noteId}", arrows: "to"}`)
  let edgesHtml = this.nodes.map((node)=>`{ from: "${focusNote.noteId}", to: "${node}", arrows: "to"}`)
                            .concat(backEdgesHtml).join(",")
  this.webview.evaluateJavaScript(this.getScript(allNodesHtml,edgesHtml),ret=>{})
  this.view.hidden = false
  this.webview.hidden = false
}
browserController.prototype.setMultiOrderNetwork = function (focusNote) {
  this.nodes = [focusNote.noteId];
  this.edges = [];
  this.noteid = focusNote.noteId
  if (self.searchDepth === -1) {
    this.getLinkNodes(focusNote,1)
  }else{
    this.getLinkNodes(focusNote,1,self.searchDepth)
  }

  let titleColor      =  ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
  let noteColorHexes  =  ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9edc"]
  let theme = this.appInstance.currentTheme
  let themeHtml = `      
    body{
      -webkit-text-fill-color: rgb(0, 0, 0);
    }`
  if (theme === "Gray") {
    titleColor      = ["#000000","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#ffffff","#ffffff","#ffffff","#ffffff","#000000","#000000","#000000","#000000"]
    noteColorHexes  = ["#d2d294","#a8d1a1","#94accf","#c88f9d","#d2d244","#5fcf3d","#459acd","#c0281b","#c46f28","#2c683a","#12328e","#9c281c","#d2d2d2","#b4b4b4","#949494","#9c82b5"]
    themeHtml = `      
    body{
      background-color: #414141;
      -webkit-text-fill-color: rgb(255, 255, 255);
    }`
  }else if (theme === "Dark") {
    noteColorHexses = ["#a0a071","#809f7b","#71839e","#986d77","#a0a032","#479e2c","#33759c","#921c12","#96551c","#204f2c","#0c266c","#771e14","#a0a0a0","#898989","#717171","#77638a"]
    themeHtml = `      
    body{
      background-color: #121212;
      -webkit-text-fill-color: rgb(233, 232, 232);
    }`
  }
  if (this.nodes.length > 30) {
    this.appInstance.showHUD(this.nodes.length+" nodes in rendering...",this.view.window,2)
  }
  let backLinedNotes = this.getBackLinks(focusNote)
  let backLinkHtml = backLinedNotes.map(node=>{
    let backgroundColor = noteColorHexes[node.colorIndex]
    let fontColor = titleColor[node.colorIndex]
    return this.getNodeInfo(node,backgroundColor,fontColor);
  })
  let backEdgesHtml = backLinedNotes.map(note=>`{ from: "${note.noteId}", to: "${focusNote.noteId}", arrows: "to"}`).join(",")
  // this.appInstance.showHUD("length:"+backLinedNotes.length,this.view.window,2)
  let nodesHtml = this.nodes.map((node)=>{
    try {
      let nodeNote = Database.sharedInstance().getNoteById(node)
      let backgroundColor = noteColorHexes[nodeNote.colorIndex]
      let fontColor = titleColor[nodeNote.colorIndex]
      return this.getNodeInfo(nodeNote,backgroundColor,fontColor);
    } catch (error) {
      this.appInstance.showHUD(error,this.view.window,2)
      return `{ 
        id: "${node}",
        label: "error", 
        title: "${error}", 
        shape:"box",
        margin:10,
        borderWidth:${node === focusNote.noteId?3:1},
        mass:${Math.sqrt(5)},
        widthConstraint:{maximum:150}
      }`
    }
  }).concat(backLinkHtml)
  .join(",")
  UIPasteboard.generalPasteboard().string = nodesHtml
  this.nodes.forEach(node=>{
    let nodeNote = Database.sharedInstance().getNoteById(node)
    if (nodeNote.linkedNotes.length !== 0) {
      let nodeEdges = nodeNote.linkedNotes.map(note=>`{ from: "${node}", to: "${note.noteid}", arrows: "to"}`).join(",")
      this.edges.push(nodeEdges)
    }
  })
  let edgesHtml = this.edges.concat(backEdgesHtml).join(",")

          // UIPasteboard.generalPasteboard().string = comment.html
  this.webview.evaluateJavaScript(this.getScript(nodesHtml,edgesHtml),ret=>{})
  this.view.hidden = false
  this.webview.hidden = false
}
browserController.prototype.getLinkNodes = function (note,depth = 1,maxdepth=100) {
  let filterNotes = note.linkedNotes.filter(linkedNote=>{
    if (this.nodes.includes(linkedNote.noteid)) {
      return false
    }
    let nodeNote =  Database.sharedInstance().getNoteById(linkedNote.noteid)
    if (nodeNote) {
      return this.color[nodeNote.colorIndex]
    }else{
      return false
    }
  
  })
  if (filterNotes.length === 0) {
    return
  }
  this.nodes = this.nodes.concat(filterNotes.map(note=>note.noteid))
  if (depth>=maxdepth) {
    return;
  }
  // this.appInstance.showHUD("nodes: "+this.nodes.length,this.view.window,2)
  filterNotes.forEach(note=>{
    let nodeNote = Database.sharedInstance().getNoteById(note.noteid)
    this.getLinkNodes(nodeNote,depth+1,maxdepth)
  })
}

browserController.prototype.getNodeInfo = function (nodeNote,backgroundColor,titleColor) {
  // let color = noteColorHexes[nodeNote.colorIndex]
  let excerpt
  let label
  if (nodeNote.excerptPic) {
    let imageData = Database.sharedInstance().getMediaByHash(nodeNote.excerptPic.paint)
    excerpt = `<img width="100%" src="data:image/jpeg;base64,${imageData.base64Encoding()}"/>`
    label = nodeNote.noteTitle?nodeNote.noteTitle:"image"
  }else{
    excerpt = nodeNote.excerptText?nodeNote.excerptText:""
    if (excerpt.length>100) {
      excerpt = (excerpt.slice(0,100)+"...").replaceAll(`\n`,`\\n`)
    }
    label = nodeNote.noteTitle?nodeNote.noteTitle.replaceAll(/;|；/g,";\n"):excerpt
  }
  let comments = nodeNote.comments.map(comment=>{
    if (comment.type === "TextNote") {
      if (/^marginnote3app/.test(comment.text)){
        return""
      }
      return `<div class="comment">${comment.text}</div>`
    }else if (comment.type === "PaintNote") {
      if (comment.paint) {
        let commentImage = Database.sharedInstance().getMediaByHash(comment.paint)
        return `<img width="100%" src="data:image/jpeg;base64,${commentImage.base64Encoding()}"/>`
      }else{
        return `<div class="comment">------------\n
                Hand writing\n
                ------------</div>`
      }
    }else if(comment.type === "HtmlNote"){
    
        // UIPasteboard.generalPasteboard().string = comment.html
      return comment.html
    }else{
      return ""
    }
  }).join("\n").replaceAll(`\n`,`\\n`)
  return `{ 
    id: "${nodeNote.noteId}",
    label: "${label?label.replaceAll(`\n`,`\\n`):"undefined"}", 
    title:preTitle(\`<div class="linkedNode" style="border: 3px solid ${backgroundColor}"><div class="head" style="background-color:${backgroundColor}"><div class="title" style="color:${titleColor}">${nodeNote.noteTitle?nodeNote.noteTitle:"..."}</div></div><p class="excerpt">${excerpt}</p>${comments}<div class="tail"></div></div>\`), 
    color:"${backgroundColor}",
    font:{color:"${titleColor}"},
    shape:"box",
    margin:10,
    mass:${Math.sqrt(label?label.length:9)},
    widthConstraint:{maximum:150}
  }`
}

browserController.prototype.getScript = function (nodesHtml,edgesHtml) {
  return `
    var nodes = new vis.DataSet([${nodesHtml}]);
    var edges = new vis.DataSet([${edgesHtml}]);
    var container = document.getElementById('mynetwork');
    var data = { nodes: nodes, edges: edges };
    var options = {layout:{randomSeed:1}};
    var network = new vis.Network(container, data, options);
    var dateNow = Date.now()
    network.on('click',function(properties){
      if (properties.nodes.length) {
        if (Date.now()-dateNow < 500) {
          window.location.assign("marginnote3app://note/"+properties.nodes[0]);//在當前界面打開鏈接
        }
      dateNow = Date.now()
      }
    })
    function preTitle(text) {
      const container = document.createElement("pre");
      container.innerHTML = text;
      return container;
    }`
}
browserController.prototype.getBackLinks = function (focusNote) {
  if (!this.backLink) {
    return [];
  }
  let title = focusNote.noteTitle
  let titleKeywords
  if (/;/.test(title)) {
    titleKeywords = title.split(";").map(key=>key.trim())
  }else{
    titleKeywords = title.split("；").map(key=>key.trim())
  }
  let backLinedNotes = Database.sharedInstance().getNotebookById(this.notebookid).notes.filter((node)=>{
      if (!this.color[node.colorIndex] || this.nodes.includes(node.noteId) || node.noteId === focusNote.noteId) {
        return false
      }
      let backLink = node.linkedNotes.some(linkedNote=>linkedNote.noteid === focusNote.noteId)
      if (backLink) { return true }
      let allText = (node.excerptText?node.excerptText:"")+(node.notesText?node.notesText:"")
      return titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)
    })
  return backLinedNotes
}
browserController.prototype.getTitleLinks = function (focusNote) {
  if (!this.titleLink) {
    return [];
  }
  if (!focusNote.noteTitle) {
    return
  }
  let title = focusNote.noteTitle
  let titleKeywords
  if (/;/.test(title)) {
    titleKeywords = title.split(";").map(key=>key.trim())
  }else{
    titleKeywords = title.split("；").map(key=>key.trim())
  }
  let titleLinkNotes = Database.shareInstance().getNotebookById(this.notebookid).notes.filter((node)=>{
    if (node.noteId === focusNote.noteId) {
      return false
    }
    let allText = (node.excerptText?node.excerptText:"")+(node.notesText?node.notesText:"")
      return titleKeywords.some(keyword=>allText.indexOf(keyword)!==-1)
    })
  return titleLinkNotes
}
browserController.prototype.show = function () {
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0
  this.view.hidden = false
  this.webview.hidden = false
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = preOpacity
  })
}
browserController.prototype.hide = function () {
  let preOpacity = this.view.layer.opacity
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = 0
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
  })
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }